import time # per tenere traccia del tempo speso
import random # per generare array di numeri pseudo-casuali

def merge(A, B):
    i = 0
    j = 0
    k = 0
    dest = [0] * (len(A) + len(B))
    while i < len(A) and j < len(B):
        if A[i] < B[j]:
            dest[k] = A[i]
            i += 1
        else:
            dest[k] = B[j]
            j += 1
        k += 1
    while i < len(A):
        dest[k] = A[i]
        i += 1
        k += 1
    while j < len(B):
        dest[k] = B[j]
        j += 1
        k += 1
    return dest


def mergesort(A):
    if len(A) > 1:
        center = len(A)//2
        left = mergesort(A[0:center]) # da 0 a center - 1
        right = mergesort(A[center:len(A)]) # da center a len(A) - 1
        return merge(left, right)
    else: #array lungo al più 1
        return A


def insertion_sort(A):
    for i in range(1, len(A)):
        j = i
        while j >= 1 and A[j] < A[j-1]:
            tmp = A[j]
            A[j] = A[j-1]
            A[j-1] = tmp
            j = j - 1
    return A


def selection_sort(A):
    for i in range(len(A)-1, 0, -1):
        max_i = i
        for j in range(0, i):
            if A[j] > A[max_i]:
                max_i = j
        tmp = A[max_i]
        A[max_i] = A[i]
        A[i] = tmp
    return A


def bubble_sort(A):
    for i in range(len(A)-1, 0, -1):
        for j in range(0, i):
            if A[j] > A[j+1]:
                tmp = A[j]
                A[j] = A[j+1]
                A[j+1] = tmp
    return A


def partition(A, p, r):
    pivot = A[r]
    i = p-1
    for j in range(p, r):
        if A[j] < pivot:
            i += 1
            A[j], A[i] = A[i], A[j]
    A[i+1], A[r] = A[r], A[i+1]
    return i+1


def quicksort_helper(A, p, r):
    if p < r:
        q = partition(A, p, r)
        quicksort_helper(A, p, q-1)
        quicksort_helper(A, q+1, r)
    return A


def quicksort(A):
    return quicksort_helper(A, 0, len(A)-1)


# creazione di un array di numeri pseudo-casuali
# di lunghezza n

def array_casuale(n, a, b):
    A = [0] * n
    for i in range(0, n):
        A[i] = random.randint(a, b)
    return A

# funzione che valura un algoritmo
# - "algoritmo" sarà il nome della funzione che vogliamo
#  chimare per ordinare i numeri

def valuta_algoritmo(algoritmo, n):
    A = array_casuale(n, 0, n)
    start = time.perf_counter()
    algoritmo(A)
    end = time.perf_counter()
    return end - start


def compara(n):
    print("Su dimensione " + str(n) + " i tempi degli algoritmi sono, in secondi:")
    tempo_insertion_sort = valuta_algoritmo(insertion_sort, n)
    tempo_selection_sort = valuta_algoritmo(selection_sort, n)
    tempo_bubble_sort = valuta_algoritmo(bubble_sort, n)
    tempo_mergesort = valuta_algoritmo(mergesort, n)
    tempo_quicksort = valuta_algoritmo(quicksort, n)
    print("insertion sort: " + str(tempo_insertion_sort))
    print("selection sort: " + str(tempo_selection_sort))
    print("bubble sort:    " + str(tempo_bubble_sort))
    print("mergesort:      " + str(tempo_mergesort))
    print("quicksort:      " + str(tempo_quicksort))
